#!/bin/sh

#Get files and dirs
CFGFILES=`egrep -e "^cfg_file=" /etc/nagios/nagios.cfg|cut -d "=" -f 2`
CFGDIRS=`egrep -e "^cfg_dir=" /etc/nagios/nagios.cfg|cut -d "=" -f 2`

#add files in cfg_dir's to filelist
for CFGDIR in $CFGDIRS; do
	CFGFILES="$CFGFILES `ls $CFGDIR/*.cfg` "
done

GROUPLIST=""

# Get groupnames from files
for CFGFILE in `echo $CFGFILES`; do
	if [ -f $CFGFILE ]; then
		HOSTGROUPS=`egrep -e "^[ 	]*hostgroup_name" $CFGFILE|awk '{print $2}'| tr "," " "`
		GROUPLIST="$GROUPLIST $HOSTGROUPS"
	fi
done

#Sort and remove duplicated names
GROUPLIST=`echo $GROUPLIST|tr " " "\n"|sort|uniq`
#echo "Grouplist: $GROUPLIST"

#Begin the HTML-output

echo "Content-type: text/html"
echo ""

#Insert the top of the frame
cat /usr/share/nagios/htdocs/side1.html

#Generate HTML for group-list
N=0
for GRP in $GROUPLIST; do
GRPNAME=`echo $GRP|sed -e 's/ /%2D/g'`
printf "<tr><td width=13><img src=images/greendot.gif"
printf " width=13 height=14 name=hostgroup$N-dot></td>\n"
printf "<td nowrap><a href=cgi-bin/status.cgi?hostgroup=$GRPNAME"
printf "&style=detail target=main onMouseOver=switchdot('hostgroup$N-dot',1)"
printf " onMouseOut=switchdot('hostgroup$N-dot',0) class=NavBarItem>"
#printf "$N-dot"
#printf ',0)" class="NavBarItem">'
printf "$GRP</a></td>\n"
echo "</tr>"
N=`echo $N+1|bc`
done

#Append bottom of frame
cat /usr/share/nagios/htdocs/side2.html
