README.pgsql for nagios in Debian GNU/Linux
$Id: README.pgsql 825 2005-12-08 13:12:24Z seanius $

Welcome to the nagios-pgsql package!

nagios-pgsql now ships with dbconfig-common support, meaning you
can have automated assistance in configuring the database-related
aspects of nagios.  however, if you choose to decline this assistance,
information in this file may be of help.

INSTALLING AND CONFIGURING NAGIOS/POSTGRESQL

= Introduction =

   Tested on Apache 1.3.33-2, nagios-pgsql 1.3-0+pre6, PostgreSQL 7.4.6-5 on Debian
   Sarge (testing); all packages from Debian repositories

= Installation =

   Next, we will setup the PostgreSQL database:

# su postgres
# createuser -A -D nagios
# createdb -O nagios nagios
# psql nagios < /usr/share/doc/nagios-pgsql/create_pgsql
# createlang plpgsql nagios
# psql nagios

   copy/paste the following in psql (alternatively, do each individual
   grant):

-- pgx_grant(PRIVILEGE, TABLES, USER)
--  Grants PRIVILEGE to USER on objects like TABLES%
--  Grants to tables, views and sequences.
--
CREATE FUNCTION pgx_grant(text,text,text) returns int4 as '
DECLARE
  priv ALIAS FOR $1;
  patt ALIAS FOR $2;
  user ALIAS FOR $3;
  obj  record;
  num  integer;
BEGIN
  num:=0;
  FOR obj IN SELECT relname FROM pg_class
  WHERE relname LIKE patt || \'%\' AND relkind in (\'r\',\'v\',\'S\') LOOP
    EXECUTE \'GRANT \' || priv || \' ON \' || obj.relname || \' TO \' || user;
    num := num + 1;
  END LOOP;
  RETURN num;
END;
' language 'plpgsql';

   (continued)

select pgx_grant('ALL','host%','nagios');
select pgx_grant('ALL','service%','nagios');
select pgx_grant('ALL','program%','nagios');
ALTER USER nagios PASSWORD 'USER_DESIRED_PASSWORD';

= Configuration =

   You will need to use the check_nagios_db plugin.  First,
   test it standalone:

sudo -u nagios /usr/lib/nagios/plugins/check_nagios_db -D pgsql

   vi /etc/nagios/database.cfg

:%s/somehost/localhost/g
:%s/somedatabase/nagios/g
:%s/someuser/nagios/g
:%s/somepassword/USER_DESIRED_PASSWORD/g
:%s/#x/x/g
:%s/someport/5432/g

   Repeat same for /etc/nagios/cgi.cfg.  If you are security-minded,
   it has been pointed out that you can create a seperate user, to
   whom you can grant restricted permissions to be used by the cgi scripts:

# createuser -A -D nagios_cgi

in psql:

ALTER USER nagios_cgi PASSWORD 'my-secret-cgi-password';

GRANT SELECT ON hostextinfo, programstatus, servicestatus, hoststatus, hostcomments, servicecomments, hostdowntime, servicedowntime, serviceextinfo TO nagios_cgi;

Then the user and password for nagios_cgi should be entered in
/etc/nagios/cgi.cfg.

   In the same file, change the check command:

nagios_check_command=/usr/lib/nagios/plugins/check_nagios_db

   Check and restart:

# nagios -v /etc/nagios/nagios.cfg
# /etc/init.d/nagios restart
# apachectl graceful

   You can now edit /etc/nagios/*.cfg files to add your own checks.

= Testing =

   http://localhost/cgi-bin/nagios/summary.cgi
   http://localhost/cgi-bin/nagios/tac.cgi

= Debugging =

   To look at the most interesting logs:

# tail -f /var/log/nagios/nagios.log /var/log/apache/* /var/log/postgresql/

   Remember that the Nagios CGI config (cgi.cfg) is separate and
   autonomous from nagios configuration.

= References =

     * http://arstechnica.com/columns/linux/linux-20040601.ars
     * http://www.xach.com/aolserver/mysql-to-postgresql.html
     * http://www.archonet.com/pgdocs/grant-all.html

= Credits =

   Originally by: Ricky Ng-Adam, rngadam@yahoo.com, January 2005
   Currently maintained by: Sean Finney <seanius@debian.org>
   Additional comments/corrections from:
   	Marcus Better <marcus@better.se>
	  - pointing out nagios needed to be owner of databases.
	  - pointing out cgi scripts could be granted less privileges
	    by creating a seperate user.


